#include <bits/stdc++.h>
using namespace std;
const int MOD = 998244353;
long long bin_pow(long long a, int b) {
    if (b == 0) return 1;
    if (b % 2 == 0) {
        long long x = bin_pow(a, b / 2) % MOD;
        return (x * x) % MOD;
    }
    return (a * bin_pow(a, b - 1)) % MOD;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long n, qw; cin >> n >> qw;
    vector<int> p(n + 1);
    for (int i = 1; i <= n; i++) cin >> p[i];
    for (int v = 0; v < qw; v++) {
        int x; cin >> x;
        vector<int> g(n + 1, 0);
        if (x == 1) {
            for (int i = 1; i <= n; i++) {
                g[i] = p[n - i + 1];
            }
        } else if (x == 2) {
            for (int i = 1; i <= n; i++) {
                g[i] = n - p[i] + 1;
            }
        } else {
            for (int i = 1; i <= n; i++) {
                g[p[i]] = i;
            }
        }
        p = g;
        long long ans = 0;
        for (int i = 1; i <= n; i++) {
            ans += bin_pow(p[i], i);
        }
        cout << ans % MOD << " ";
    }
    
}